(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var _ = Package.underscore._;
var Random = Package.random.Random;
var Router = Package['iron:router'].Router;
var RouteController = Package['iron:router'].RouteController;
var Accounts = Package['accounts-base'].Accounts;
var check = Package.check.check;
var Match = Package.check.Match;
var SHA256 = Package.sha.SHA256;
var Email = Package.email.Email;
var Iron = Package['iron:core'].Iron;

(function () {

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                             //
// packages/accounts-email-token/token_common.js                                                               //
//                                                                                                             //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                               //
Accounts.emailToken = {};                                                                                      // 1
                                                                                                               // 2
Accounts.emailToken._hashToken = function (token) {                                                            // 3
  return {                                                                                                     // 4
    digest: SHA256(token),                                                                                     // 5
    algorithm: "sha-256"                                                                                       // 6
  };                                                                                                           // 7
};                                                                                                             // 8
                                                                                                               // 9
var enabled = false;                                                                                           // 10
                                                                                                               // 11
Accounts.emailToken.enable = function () {                                                                     // 12
  enabled = true;                                                                                              // 13
  if (Meteor.isClient) {                                                                                       // 14
    Accounts.ui.registerService("emailToken", "an Email + Token");                                             // 15
  }                                                                                                            // 16
};                                                                                                             // 17
                                                                                                               // 18
Accounts.emailToken.disable = function () {                                                                    // 19
  enabled = false;                                                                                             // 20
  if (Meteor.isClient) {                                                                                       // 21
    Accounts.ui.deregisterService("emailToken");                                                               // 22
  }                                                                                                            // 23
};                                                                                                             // 24
                                                                                                               // 25
Accounts.emailToken.isEnabled = function () {                                                                  // 26
  return enabled;                                                                                              // 27
};                                                                                                             // 28
                                                                                                               // 29
Router.route("/_emailToken/:_email/:_token", function () {                                                     // 30
  this.render("Loading");                                                                                      // 31
  var that = this;                                                                                             // 32
  Meteor.loginWithEmailToken(this.params._email, this.params._token, function (err) {                          // 33
    if (err) {                                                                                                 // 34
      that.render("_emailTokenError", {                                                                        // 35
        data: function () {                                                                                    // 36
          return {                                                                                             // 37
            error: err                                                                                         // 38
          };                                                                                                   // 39
        }                                                                                                      // 40
      });                                                                                                      // 41
    } else {                                                                                                   // 42
      Router.go("/");                                                                                          // 43
    }                                                                                                          // 44
  });                                                                                                          // 45
});                                                                                                            // 46
                                                                                                               // 47
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function () {

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                             //
// packages/accounts-email-token/token_server.js                                                               //
//                                                                                                             //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                               //
var TOKEN_EXPIRATION_MS = 15 * 60 * 1000;                                                                      // 1
                                                                                                               // 2
var cleanupExpiredTokens = function() {                                                                        // 3
  Meteor.users.update({}, {                                                                                    // 4
    $pull: {                                                                                                   // 5
      "services.emailToken.tokens": {                                                                          // 6
        createdAt: {$lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)}                                           // 7
      }                                                                                                        // 8
    }                                                                                                          // 9
  }, { multi: true });                                                                                         // 10
};                                                                                                             // 11
                                                                                                               // 12
Meteor.startup(cleanupExpiredTokens);                                                                          // 13
// Tokens can actually last up to 2 * TOKEN_EXPIRATION_MS                                                      // 14
Meteor.setInterval(cleanupExpiredTokens, TOKEN_EXPIRATION_MS);                                                 // 15
                                                                                                               // 16
var checkToken = function (user, token) {                                                                      // 17
  var found = false;                                                                                           // 18
  user.services.emailToken.tokens.forEach(function (userToken) {                                               // 19
    if((userToken.algorithm === token.algorithm) &&                                                            // 20
       (userToken.digest === token.digest)) {                                                                  // 21
      found = true;                                                                                            // 22
    }                                                                                                          // 23
  });                                                                                                          // 24
                                                                                                               // 25
  return found;                                                                                                // 26
};                                                                                                             // 27
                                                                                                               // 28
// The name of the email package to use. It refers to a variable named in the global scope.                    // 29
var EMAIL_PACKAGE= "Email";                                                                                    // 30
                                                                                                               // 31
Accounts.emailToken.setEmailPackage = function (packageName) {                                                 // 32
  EMAIL_PACKAGE = packageName;                                                                                 // 33
};                                                                                                             // 34
                                                                                                               // 35
// Handler to login with a token.                                                                              // 36
Accounts.registerLoginHandler("emailToken", function (options) {                                               // 37
  if (!options.emailToken)                                                                                     // 38
    return undefined; // don't handle                                                                          // 39
                                                                                                               // 40
  options = options.emailToken;                                                                                // 41
  check(options, {                                                                                             // 42
    email: String,                                                                                             // 43
    token: String                                                                                              // 44
  });                                                                                                          // 45
                                                                                                               // 46
  var user = Meteor.users.findOne({"services.emailToken.email": options.email});                               // 47
                                                                                                               // 48
  if (!user) {                                                                                                 // 49
    console.error("User not found:", options.email);                                                           // 50
    return {                                                                                                   // 51
      error: new Meteor.Error(403, "User not found")                                                           // 52
    };                                                                                                         // 53
  }                                                                                                            // 54
                                                                                                               // 55
  if (!user.services || !user.services.emailToken ||                                                           // 56
      !(user.services.emailToken.tokens)) {                                                                    // 57
    console.error("User has no token set:", options.email);                                                    // 58
    return {                                                                                                   // 59
      error: new Meteor.Error(403, "User has no token set")                                                    // 60
    };                                                                                                         // 61
  }                                                                                                            // 62
                                                                                                               // 63
  var token = Accounts.emailToken._hashToken(options.token);                                                   // 64
  var found = checkToken(                                                                                      // 65
    user,                                                                                                      // 66
    token                                                                                                      // 67
  );                                                                                                           // 68
                                                                                                               // 69
  if (!found) {                                                                                                // 70
    console.error("Token not found:", user.services.emailToken);                                               // 71
    return {                                                                                                   // 72
      error: new Meteor.Error(403, "Invalid authentication code")                                              // 73
    };                                                                                                         // 74
  }                                                                                                            // 75
                                                                                                               // 76
  Meteor.users.update({_id: user._id}, {$pull: {"services.emailToken.tokens": token}});                        // 77
  return {                                                                                                     // 78
    userId: user._id                                                                                           // 79
  };                                                                                                           // 80
});                                                                                                            // 81
                                                                                                               // 82
var Url = Npm.require("url");                                                                                  // 83
                                                                                                               // 84
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                // 85
var HOSTNAME = ROOT_URL.hostname;                                                                              // 86
                                                                                                               // 87
var makeTokenUrl = function (email, token) {                                                                   // 88
  return process.env.ROOT_URL + "/_emailToken/" + encodeURIComponent(email) + "/" + encodeURIComponent(token); // 89
};                                                                                                             // 90
                                                                                                               // 91
///                                                                                                            // 92
/// EMAIL VERIFICATION                                                                                         // 93
///                                                                                                            // 94
var sendTokenEmail = function (email, token) {                                                                 // 95
  var options = {                                                                                              // 96
    to:  email,                                                                                                // 97
    from: HOSTNAME + " <no-reply@" + HOSTNAME + ">",                                                           // 98
    subject: "Log in to " + HOSTNAME,                                                                          // 99
    text: "To log in to " + HOSTNAME + ", click on the following link:\n\n" +                                  // 100
          makeTokenUrl(email, token) + "\n\n" +                                                                // 101
          "Alternatively, enter the following one-time authentication code into the log-in form:\n\n" +        // 102
          token + "\n\n" +                                                                                     // 103
          "You are receiving this because someone (hopefully you) requested to log in to " +                   // 104
          HOSTNAME + " with your email address. If you did not request to log into " + HOSTNAME +              // 105
          ", you may ignore this message.\n\n" +                                                               // 106
          "This information will expire in 15 minutes.\n"                                                      // 107
  };                                                                                                           // 108
                                                                                                               // 109
  global[EMAIL_PACKAGE].send(options);                                                                         // 110
};                                                                                                             // 111
                                                                                                               // 112
///                                                                                                            // 113
/// CREATING USERS                                                                                             // 114
///                                                                                                            // 115
// returns the user id                                                                                         // 116
var createAndEmailTokenForUser = function (email) {                                                            // 117
  check(email, String);                                                                                        // 118
  var atIndex = email.indexOf("@");                                                                            // 119
  if (atIndex === -1) {                                                                                        // 120
    throw new Meteor.Error(400, "No @ symbol was found in your email");                                        // 121
  }                                                                                                            // 122
                                                                                                               // 123
  var username = email.slice(0, atIndex);                                                                      // 124
                                                                                                               // 125
  var user = Meteor.users.findOne({"services.emailToken.email": email});                                       // 126
  var userId;                                                                                                  // 127
                                                                                                               // 128
  // TODO(someday): make this shorter, and handle requests that try to brute force it.                         // 129
  var token = Random.id(12);                                                                                   // 130
  var tokenObj = Accounts.emailToken._hashToken(token);                                                        // 131
  tokenObj.createdAt = new Date();                                                                             // 132
                                                                                                               // 133
  if (user) {                                                                                                  // 134
    if (user.services.emailToken.tokens && user.services.emailToken.tokens.length > 2) {                       // 135
      throw new Meteor.Error(409, "It looks like we sent a log in email to this address not long " +           // 136
        "ago. Please use the one that was already sent (check your spam folder if you can't find " +           // 137
        "it), or wait a while and try again");                                                                 // 138
    }                                                                                                          // 139
    userId = user._id;                                                                                         // 140
                                                                                                               // 141
    Meteor.users.update({_id: userId}, {$push: {"services.emailToken.tokens": tokenObj}});                     // 142
  } else {                                                                                                     // 143
    var options = {                                                                                            // 144
      email: email,                                                                                            // 145
      profile: {                                                                                               // 146
        name: username                                                                                         // 147
      }                                                                                                        // 148
    };                                                                                                         // 149
                                                                                                               // 150
    user = {services: {emailToken: {                                                                           // 151
      tokens: [tokenObj],                                                                                      // 152
      email: options.email                                                                                     // 153
    }}};                                                                                                       // 154
                                                                                                               // 155
    userId = Accounts.insertUserDoc(options, user);                                                            // 156
  }                                                                                                            // 157
                                                                                                               // 158
  sendTokenEmail(email, token);                                                                                // 159
                                                                                                               // 160
  return userId;                                                                                               // 161
};                                                                                                             // 162
                                                                                                               // 163
// method for create user. Requests come from the client.                                                      // 164
// This method will create a user if it doesn't exist, otherwise it will generate a token.                     // 165
// It will always send an email to the user                                                                    // 166
Meteor.methods({createAndEmailTokenForUser: function (email) {                                                 // 167
  if (!Accounts.emailToken.isEnabled()) {                                                                      // 168
    throw new Meteor.Error(403, "Email Token service is disabled.");                                           // 169
  }                                                                                                            // 170
  // Create user. result contains id and token.                                                                // 171
  var user = createAndEmailTokenForUser(email);                                                                // 172
}});                                                                                                           // 173
                                                                                                               // 174
///                                                                                                            // 175
/// INDEXES ON USERS                                                                                           // 176
///                                                                                                            // 177
Meteor.users._ensureIndex("services.emailToken.email",                                                         // 178
                          {unique: 1, sparse: 1});                                                             // 179
                                                                                                               // 180
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['accounts-email-token'] = {};

})();

//# sourceMappingURL=accounts-email-token.js.map
